## stdgpu-contrib 1.3.0+git20220507.32e0517

=== benchmark/CMakeLists.txt ===
include(FetchContent)

FetchContent_Declare(
    benchmark
    PREFIX benchmark
    URL https://github.com/google/benchmark/archive/refs/tags/v1.7.1.tar.gz
    URL_HASH SHA256=6430e4092653380d9dc4ccb45a1e2dc9259d581f4866dc0759713126056bc1d7
    DOWNLOAD_DIR "${STDGPU_EXTERNAL_DIR}/benchmark"
)

set(BENCHMARK_ENABLE_TESTING OFF CACHE INTERNAL "")
set(BENCHMARK_ENABLE_WERROR OFF CACHE INTERNAL "")
set(BENCHMARK_ENABLE_INSTALL OFF CACHE INTERNAL "")
set(BENCHMARK_ENABLE_DOXYGEN OFF CACHE INTERNAL "")
set(BENCHMARK_INSTALL_DOCS OFF CACHE INTERNAL "")

FetchContent_MakeAvailable(benchmark)

# Suppress clang-tidy errors on benchmark by treating it as a system library
# Use SYSTEM in FetchContent_Declare for CMake 3.25+ instead when it becomes available
get_target_property(benchmark_INCLUDE_DIRS benchmark INTERFACE_INCLUDE_DIRECTORIES)
set_target_properties(benchmark PROPERTIES INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "${benchmark_INCLUDE_DIRS}")


add_subdirectory(stdgpu)

=== test/CMakeLists.txt ===
include(FetchContent)

FetchContent_Declare(
    googletest
    PREFIX googletest
    URL https://github.com/google/googletest/archive/refs/tags/v1.13.0.zip
    URL_HASH SHA256=ffa17fbc5953900994e2deec164bb8949879ea09b411e07f215bfbb1f87f4632
    DOWNLOAD_DIR "${STDGPU_EXTERNAL_DIR}/googletest"
)

set(BUILD_GMOCK OFF CACHE INTERNAL "")
set(INSTALL_GTEST OFF CACHE INTERNAL "")

FetchContent_MakeAvailable(googletest)

# Suppress clang-tidy errors on googletest by treating it as a system library
# Use SYSTEM in FetchContent_Declare for CMake 3.25+ instead when it becomes available
get_target_property(gtest_INCLUDE_DIRS gtest INTERFACE_INCLUDE_DIRECTORIES)
set_target_properties(gtest PROPERTIES INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "${gtest_INCLUDE_DIRS}")


add_subdirectory(stdgpu)

=== src/stdgpu/openmp/CMakeLists.txt ===

find_package(OpenMP 2.0 REQUIRED)

set(STDGPU_DEPENDENCIES_BACKEND_INIT "
find_dependency(OpenMP 2.0 REQUIRED)
" PARENT_SCOPE)

target_sources(stdgpu PRIVATE impl/device.cpp
                              impl/memory.cpp)

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.23)
    target_sources(stdgpu PUBLIC FILE_SET stdgpu_backend_headers
                                 TYPE HEADERS
                                 BASE_DIRS ${STDGPU_INCLUDE_LOCAL_DIR}
                                 FILES atomic.h
                                       device.h
                                       memory.h
                                       platform.h
                                       platform_check.h)

    target_sources(stdgpu PUBLIC FILE_SET stdgpu_backend_header_implementations
                                 TYPE HEADERS
                                 BASE_DIRS ${STDGPU_INCLUDE_LOCAL_DIR}
                                 FILES impl/atomic_detail.h)
endif()

target_compile_definitions(stdgpu PUBLIC THRUST_DEVICE_SYSTEM=THRUST_DEVICE_SYSTEM_OMP)

target_link_libraries(stdgpu PUBLIC OpenMP::OpenMP_CXX)

=== test/stdgpu/hip/CMakeLists.txt ===

target_sources(teststdgpu PRIVATE atomic.hip
                                  bitset.hip
                                  deque.hip
                                  mutex.hip
                                  unordered_map.hip
                                  unordered_set.hip
                                  vector.hip)

=== debian/changelog ===
stdgpu-contrib (1.3.0+git20220507.32e0517-3) unstable; urgency=medium

  * Fix Thrust version detection (Closes: #1109841)

 -- Timo Röhling <roehling@debian.org>  Fri, 25 Jul 2025 07:32:51 +0200

stdgpu-contrib (1.3.0+git20220507.32e0517-2) unstable; urgency=medium

  * Merge stdgpu-contrib repo into stdgpu repo
  * Refresh patches from stdgpu in main
  * Build-depend on nvidia-cuda-toolkit-gcc
  * Restrict architectures to those with CUDA

 -- Timo Röhling <roehling@debian.org>  Thu, 13 Jul 2023 00:06:05 +0200

stdgpu-contrib (1.3.0+git20220507.32e0517-1) unstable; urgency=medium

  * Initial release.
    This is the stdgpu package configured to build with non-free
    dependencies (CUDA).

 -- Timo Röhling <roehling@debian.org>  Fri, 16 Jun 2023 20:18:11 +0200

=== debian/control ===
Source: stdgpu-contrib
Section: contrib/libs
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libthrust-dev,
 nvidia-cuda-toolkit-gcc,
Homepage: https://github.com/stotko/stdgpu
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/stdgpu.git -b master-contrib
Vcs-Browser: https://salsa.debian.org/debian/stdgpu
Description: Efficient STL-like Data Structures on the GPU
 stdgpu is an open-source library providing several generic GPU data structures
 for fast and reliable data management. Multiple platforms such as CUDA,
 OpenMP, and HIP are supported allowing you to rapidly write highly complex
 agnostic and native algorithms that look like sequential CPU code but are
 executed in parallel on the GPU.

Package: libstdgpu-cuda0d
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (CUDA backend)
 ${source:Extended-Description}
 .
 This package installs the shared library that runs on CUDA.

Package: libstdgpu-cuda-dev
Section: contrib/libdevel
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Conflicts: libstdgpu-dev
Provides: libstdgpu-dev
Depends:
 ${misc:Depends},
 libstdgpu-cuda0d (= ${binary:Version}),
 libthrust-dev,
Description: ${source:Synopsis} (CUDA development headers)
 ${source:Extended-Description}
 .
 This package installs the development headers for the CUDA version.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DSTDGPU_SETUP_COMPILER_FLAGS=OFF \
		-DSTDGPU_BUILD_TESTS=OFF \
		-DSTDGPU_BUILD_EXAMPLES=OFF \
		-DSTDGPU_BUILD_BENCHMARKS=OFF \
		-DSTDGPU_BUILD_SHARED_LIBS=ON \
		-DSTDGPU_BACKEND=STDGPU_BACKEND_CUDA \
		-DCMAKE_CUDA_ARCHITECTURES=all \
		-DCUDAToolkit_INCLUDE_DIR=/usr/include \
		-DSTDGPU_SOVERSION=0d \
		-DSTDGPU_OUTPUT_NAME=stdgpu_cuda

override_dh_auto_test:
